#include <vector>
#include "hash.h"

using namespace std;

namespace Msp {
namespace Crypto {

void Hash::update(const string &str)
{
	update(str.data(), str.size());
}

string Hash::get_hexdigest() const
{
	static const char hexdigits[] = "0123456789abcdef";

	vector<char> digest(get_digest_size());
	unsigned len = get_digest(&digest[0], digest.size());
	string hex(len*2, '0');
	for(unsigned i=0; i<len; ++i)
	{
		hex[i*2] = hexdigits[(digest[i]>>4)&15];
		hex[i*2+1] = hexdigits[digest[i]&15];
	}
	return hex;
}

} // namespace Crypto
} // namespace Msp
